package com.application.tak.takapplication;

import android.content.Context;
import android.support.design.widget.TabLayout;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v4.app.FragmentActivity;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;

import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.content.Intent;

import android.view.inputmethod.InputMethodManager;
import android.widget.TextView;

import com.application.tak.takapplication.data_access.Config;
import com.google.android.gms.auth.api.signin.GoogleSignIn;
import com.google.android.gms.auth.api.signin.GoogleSignInAccount;
import com.google.android.gms.tasks.Task;

public class actStudentLogin extends AppCompatActivity {

    public actStudentLoginMain loginMain;
    public actStudentLoginCode loginCode;
    public actStudentLoginDetails loginDetails;
    public actStudentLoginMainConfirmaton loginConfirmation;
    public boolean regulationAccepted = false;
    /**
     * The {@link android.support.v4.view.PagerAdapter} that will provide
     * fragments for each of the sections. We use a
     * {@link FragmentPagerAdapter} derivative, which will keep every
     * loaded fragment in memory. If this becomes too memory intensive, it
     * may be best to switch to a
     * {@link android.support.v4.app.FragmentStatePagerAdapter}.
     */
    private SectionsPagerAdapter mSectionsPagerAdapter;
    public void gotoTutorial(View v){
        Intent tutorialPage = new Intent (this, actStudentRegulation.class);
        startActivity(tutorialPage);
    }
    /**
     * The {@link ViewPager} that will host the section contents.
     */
    private ViewPager mViewPager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_student_login);

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        // Create the adapter that will return a fragment for each of the three
        // primary sections of the activity.
        mSectionsPagerAdapter = new SectionsPagerAdapter(getSupportFragmentManager());

        // Set up the ViewPager with the sections adapter.
        mViewPager = (ViewPager) findViewById(R.id.container);

        mViewPager.addOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {

                HideKeyboard();


                    if(position == 3)
                    {
                        if(Config.LoggedInStudent != null && Config.LoggedInStudent.get_Class() != null)
                            loginConfirmation.autoClassName.setText(Config.LoggedInStudent.get_Class().get_ClassName());
                        if(Config.LoggedInStudent != null && Config.LoggedInStudent.get_School() != null)
                            loginConfirmation.autoSchoolName.setText(Config.LoggedInStudent.get_School().get_SchoolName());
                    }

            }

            @Override
            public void onPageSelected(int position) {

                HideKeyboard();
                if(position == 3)
                {
                    if(Config.LoggedInStudent != null && Config.LoggedInStudent.get_Class() != null)
                        loginConfirmation.autoClassName.setText(Config.LoggedInStudent.get_Class().get_ClassName());
                    if(Config.LoggedInStudent != null && Config.LoggedInStudent.get_School() != null)
                        loginConfirmation.autoSchoolName.setText(Config.LoggedInStudent.get_School().get_SchoolName());
                }
            }

            @Override
            public void onPageScrollStateChanged(int state) {

            }
        });

        mViewPager.setAdapter(mSectionsPagerAdapter);

        TabLayout tabLayout = (TabLayout) findViewById(R.id.tabs);
        tabLayout.setupWithViewPager(mViewPager);

    }

    public void SetCurrentItem(Integer i)
    {
        mViewPager.setCurrentItem(i);

    }

    void HideKeyboard()
    {
        View focused = getCurrentFocus();
        if (focused != null) {
           // focused.clearFocus();
            InputMethodManager imm = (InputMethodManager) this.getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(focused.getWindowToken(),0);
        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(loginMain != null)
        loginMain.callbackManager.onActivityResult(requestCode, resultCode, data);

    }


    /**
     * A placeholder fragment containing a simple view.
     */
    public static class PlaceholderFragment extends Fragment {
        /**
         * The fragment argument representing the section number for this
         * fragment.
         */
        private static final String ARG_SECTION_NUMBER = "section_number";

        public PlaceholderFragment() {
        }

        /**
         * Returns a new instance of this fragment for the given section
         * number.
         */
        public static PlaceholderFragment newInstance(int sectionNumber) {
            PlaceholderFragment fragment = new PlaceholderFragment();
            Bundle args = new Bundle();
            args.putInt(ARG_SECTION_NUMBER, sectionNumber);
            fragment.setArguments(args);
            return fragment;
        }

        @Override
        public View onCreateView(LayoutInflater inflater, ViewGroup container,
                                 Bundle savedInstanceState) {
            View rootView = inflater.inflate(R.layout.act_student_login_main, container, false);
            TextView textView = (TextView) rootView.findViewById(R.id.section_label);

            return rootView;


        }
    }

    /**
     * A {@link FragmentPagerAdapter} that returns a fragment corresponding to
     * one of the sections/tabs/pages.
     */
    public class SectionsPagerAdapter extends FragmentPagerAdapter {

        public SectionsPagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int position) {
            switch (position) {
                case 0:
                    if(loginMain == null)
                        loginMain = new actStudentLoginMain();
                    return loginMain;
                case 1:
                    if(loginCode == null)
                        loginCode = new actStudentLoginCode();
                    return loginCode;
                case 2:
                    if(loginDetails == null)
                        loginDetails = new actStudentLoginDetails();
                    return loginDetails;
                case 3:
                    if(loginConfirmation == null)
                        loginConfirmation = new actStudentLoginMainConfirmaton();
                    return loginConfirmation;
                default:
                    return  null;
            }
        }

        @Override
        public int getCount() {
            // Show 3 total pages.
            return 4;
        }



        @Override
        public CharSequence getPageTitle(int position) {
            switch (position) {
                case 0:
                    return "Krok 1";
                case 1:
                    return "Krok 2";
                case 2:
                    return "Krok 3";
                case 3:
                    return "Krok 4";
            }
            return null;
        }
    }
}
